/*
 * Classes:
 *  CViewContactScreenPart
 *  CNewContactScreenPart
 */

function CViewContactScreenPart(skinName)
{
	this._skinName = skinName;
	this.Contact = null;
	this._contactEmail = '';
	this._contactHEmail = '';
	this._contactBEmail = '';
	this._contactOtherEmail = '';
	this._contactHWeb = '';
	this._contactBWeb = '';

	this._mainTbl = null;
	this._fullnameObj = null;
	this._fullnameCont = null;
	this._defaultEmailObj = null;
	this._defaultEmailCont = null;
	this._birthdayObj = null;
	this._birthdayCont = null;

	this._personalTbl = null;
	this._hEmailObj = null;
	this._hEmailCont = null;
	this._hStreetObj = null;
	this._hStreetCont = null;
	this._hCityTitle = null;
	this._hCityObj = null;
	this._hFaxTitle = null;
	this._hFaxObj = null;
	this._hCityFaxCont = null;
	this._hStateTitle = null;
	this._hStateObj = null;
	this._hPhoneTitle = null;
	this._hPhoneObj = null;
	this._hStatePhoneCont = null;
	this._hZipTitle = null;
	this._hZipObj = null;
	this._hMobileTitle = null;
	this._hMobileObj = null;
	this._hZipMobileCont = null;
	this._hCountryObj = null;
	this._hCountryCont = null;
	this._hWebObj = null;
	this._hWebCont = null;

	this._businessTbl = null;
	this._bEmailObj = null;
	this._bEmailCont = null;
	this._bCompanyTitle = null;
	this._bCompanyObj = null;
	this._bJobTitleTitle = null;
	this._bJobTitleObj = null;
	this._bCompanyJobTitleCont = null;
	this._bDepartmentTitle = null;
	this._bDepartmentObj = null;
	this._bOfficeTitle = null;
	this._bOfficeObj = null;
	this._bDepartmentOfficeCont = null;
	this._bStreetObj = null;
	this._bStreetCont = null;
	this._bCityTitle = null;
	this._bCityObj = null;
	this._bFaxTitle = null;
	this._bFaxObj = null;
	this._bCityFaxCont = null;
	this._bStateTitle = null;
	this._bStateObj = null;
	this._bPhoneTitle = null;
	this._bPhoneObj = null;
	this._bStatePhoneCont = null;
	this._bZipTitle = null;
	this._bZipObj = null;
	this._bCountryTitle = null;
	this._bCountryObj = null;
	this._bZipCountryCont = null;
	this._bWebObj = null;
	this._bWebCont = null;

	this._otherTbl = null;
	this._otherEmailObj = null;
	this._otherEmailCont = null;
	this._notesObj = null;
	this._notesCont = null;

	this._groupsTbl = null;
	this._groupsObj = null;

	this._editTbl = null;
		
	this._sectionClassName = 'wm_contacts_view';
	this._titleClassName = 'wm_contacts_view_title';
	this._nameClassName = 'wm_contacts_name';
	this._emailClassName = 'wm_contacts_email';
	this._sectionNameClassName = 'wm_contacts_section_name';

	this.Show = function ()
	{
		this._mainTbl.className = '';
		this.Fill();
	};
	
	this.Hide = function ()
	{
		this._mainTbl.className = 'wm_hide';
	};
	
	this.UpdateContact = function (Data)
	{
		this.Contact = Data;
	};
	
	this.Fill = function ()
	{
		this.FillDefSection(this.Contact);
		this.FillHomeSection(this.Contact);
		this.FillBusinessSection(this.Contact);
		this.FillOtherSection(this.Contact);
		this.FillGroupSection(this.Contact);
		this._editTbl.className = this._sectionClassName;
	}; // Fill
	
	this.FillGroupSection = function (cont)
	{
		var emptySection = true;
		CleanNode(this._groupsObj);
		var groups = cont.Groups;
		var iCount = groups.length;
		var span;
		for (var i=0; i<iCount; i++) {
			var a = CreateChildWithAttrs(this._groupsObj, 'a', [['href', '#']]);
			a.onclick = function () { return false; };
			a.innerHTML = groups[i].Name;
			a.id = groups[i].Id;
			a.onclick = function () {
				SetHistoryHandler(
					{
						ScreenId: SCREEN_CONTACTS,
						Entity: PART_VIEW_GROUP,
						IdGroup: this.id
					}
				);
				return false;
			};
			emptySection = false;
			span = CreateChild(this._groupsObj, 'span');
			span.innerHTML = ',&nbsp;';
		}
		if (iCount > 0) span.innerHTML = '';
		if (emptySection) this._groupsTbl.className = 'wm_hide';
		else this._groupsTbl.className = this._sectionClassName;
	};
	
	this.Build = function (container)
	{
		var tbl = CreateChild(container, 'table');
		this._mainTbl = tbl;
		tbl.style.width = '100%';
		var tr = tbl.insertRow(0);
		var td = tr.insertCell(0);
		/*rtl*/
		td.style.textAlign = window.LEFT;
		this.BuildContactView(td);
		
		var td = tr.insertCell(1);
		td.style.textAlign = window.RIGHT;
		td.style.verticalAlign = 'top';
		this.BuildMailSearch(td);
	};
	
	this.BuildGroupSection = function (container)
	{
		var tbl = CreateChild(container, 'table');
		this._groupsTbl = tbl;
		tbl.className = 'wm_hide';
		var tr = tbl.insertRow(0);
		var td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title wm_contacts_section_name';
		td.innerHTML = Lang.Groups;
		WebMail.LangChanger.Register('innerHTML', td, 'Groups', '');
		td = tr.insertCell(1);
		td.className = 'wm_contacts_groups';
		this._groupsObj = td;
	};
	
	this.BuildContactView = function (container)
	{
		this.BuildDefSection(container);
		this.BuildHomeSection(container);
		this.BuildBusinessSection(container);
		this.BuildOtherSection(container);
		this.BuildGroupSection(container);

		var obj = this;
		this._defaultEmailObj.onclick = function () { MailToHandler(obj._contactEmail); return false; };
		this._hEmailObj.onclick = function () { MailToHandler(obj._contactHEmail); return false; };
		this._bEmailObj.onclick = function () { MailToHandler(obj._contactBEmail); return false; };
		this._otherEmailObj.onclick = function () { MailToHandler(obj._contactOtherEmail); return false; };
		this._hWebObj.onclick = function () { OpenURL(obj._contactHWeb); return false; };
		this._bWebObj.onclick = function () { OpenURL(obj._contactBWeb); return false; };
		
		var tbl = CreateChild(container, 'table');
		tbl.style.marginBottom = '10px';
		this._editTbl = tbl;
		tbl.className = 'wm_hide';
		var tr = tbl.insertRow(0);
		var td = tr.insertCell(0);
		var a = CreateChildWithAttrs(td, 'a', [['href', '#']]);
		a.onclick = function () {
			SetHistoryHandler(
				{
					ScreenId: SCREEN_CONTACTS,
					Entity: PART_EDIT_CONTACT,
					IdAddr: obj.Contact.Id
				}
			);
			return false;
		};
		a.innerHTML = Lang.EditContact;
		WebMail.LangChanger.Register('innerHTML', a, 'EditContact', '');
	};
	
	this.BuildMailSearch = function (container)
	{
		var obj = this;
		/*rtl*/
		var div = CreateChildWithAttrs(container, 'div', [['style', 'float: ' + window.RIGHT + ';']]);
		div.style.margin = '20px 20px 10px';
		div.className = 'wm_button_link wm_control';
		div.onclick = function () { MailToHandler(obj._contactEmail); return false; };
		div.innerHTML = Lang.ContactMail;
		div = CreateChildWithAttrs(container, 'div', [['style', 'width: 0; height: 0; padding: 0; overflow: hidden; clear: both;']]);
		
		div = CreateChild(container, 'div');
		div.style.margin = '10px 20px 20px';
		a = CreateChild(div, 'a');
		a.href = '#';
		a.onclick = function () { ViewAllContactMailsHandler(obj.Contact); return false; };
		a.innerHTML = Lang.ContactViewAllMails;
	}
}

var ViewContactPrototype = {
	FillDefSection: function (cont)
	{
		if (cont.Name.length > 0) {
			this._fullnameObj.innerHTML = cont.Name;
			this._fullnameCont.className = '';
		}
		else this._fullnameCont.className = 'wm_hide';
		if (cont.Email.length > 0) {
			this._contactEmail = (cont.UseFriendlyNm && cont.Name.length > 0)
				? '"' + cont.Name + '" <' + HtmlDecode(cont.Email) + '>'
				: HtmlDecode(cont.Email);
			this._defaultEmailObj.innerHTML = cont.Email;
			this._defaultEmailCont.className = '';
		}
		else this._defaultEmailCont.className = 'wm_hide';
		var birthDay = GetBirthDay(cont.Day, cont.Month, cont.Year);
		if (birthDay.length > 0) {
			this._birthdayObj.innerHTML = birthDay;
			this._birthdayCont.className = '';
		}
		else this._birthdayCont.className = 'wm_hide';
	},
	
	FillHomeSection: function (cont)
	{
		var emptySection = true;
		if (cont.hEmail.length > 0 && cont.PrimaryEmail != PRIMARY_HOME_EMAIL) {
			this._contactHEmail = (cont.UseFriendlyNm && cont.Name.length > 0)
				? '"' + cont.Name + '" <' + HtmlDecode(cont.hEmail) + '>'
				: HtmlDecode(cont.hEmail);
			this._hEmailObj.innerHTML = cont.hEmail;
			this._hEmailCont.className = '';
			emptySection = false;
		}
		else this._hEmailCont.className = 'wm_hide';
		if (cont.hStreet.length > 0) {
			this._hStreetObj.innerHTML = cont.hStreet;
			this._hStreetCont.className = '';
			emptySection = false;
		}
		else this._hStreetCont.className = 'wm_hide';
		if (cont.hCity.length > 0 || cont.hFax.length > 0) {
			this._hCityObj.innerHTML = cont.hCity;
			this._hCityTitle.innerHTML = (cont.hCity.length > 0) ? Lang.City + ':' : '';
			this._hFaxObj.innerHTML = cont.hFax;
			this._hFaxTitle.innerHTML = (cont.hFax.length > 0) ? Lang.Fax + ':' : '';
			this._hCityFaxCont.className = '';
			emptySection = false;
		}
		else this._hCityFaxCont.className = 'wm_hide';
		if (cont.hState.length > 0 || cont.hPhone.length > 0) {
			this._hStateObj.innerHTML = cont.hState;
			this._hStateTitle.innerHTML = (cont.hState.length > 0) ? Lang.StateProvince + ':' : '';
			this._hPhoneObj.innerHTML = cont.hPhone;
			this._hPhoneTitle.innerHTML = (cont.hPhone.length > 0) ? Lang.Phone + ':' : '';
			this._hStatePhoneCont.className = '';
			emptySection = false;
		}
		else this._hStatePhoneCont.className = 'wm_hide';
		if (cont.hZip.length > 0 || cont.hMobile.length > 0) {
			this._hZipObj.innerHTML = cont.hZip;
			this._hZipTitle.innerHTML = (cont.hZip.length > 0) ? Lang.ZipCode + ':' : '';
			this._hMobileObj.innerHTML = cont.hMobile;
			this._hMobileTitle.innerHTML = (cont.hMobile.length > 0) ? Lang.Mobile + ':' : '';
			this._hZipMobileCont.className = '';
			emptySection = false;
		}
		else this._hZipMobileCont.className = 'wm_hide';
		if (cont.hCountry.length > 0) {
			this._hCountryObj.innerHTML = cont.hCountry;
			this._hCountryCont.className = '';
			emptySection = false;
		}
		else this._hCountryCont.className = 'wm_hide';
		if (cont.hWeb.length > 0) {
			this._contactHWeb = cont.hWeb;
			this._hWebObj.innerHTML = cont.hWeb;
			this._hWebCont.className = '';
			emptySection = false;
		}
		else this._hWebCont.className = 'wm_hide';
		if (emptySection) this._personalTbl.className = 'wm_hide';
		else this._personalTbl.className = this._sectionClassName;
	},
	
	FillBusinessSection: function (cont)
	{
		var emptySection = true;
		if (cont.bEmail.length > 0 && cont.PrimaryEmail != PRIMARY_BUSS_EMAIL) {
			this._contactBEmail = (cont.UseFriendlyNm && cont.Name.length > 0)
				? '"' + cont.Name + '" <' + HtmlDecode(cont.bEmail) + '>'
				: HtmlDecode(cont.bEmail);
			this._bEmailObj.innerHTML = cont.bEmail;
			this._bEmailCont.className = '';
			emptySection = false;
		}
		else this._bEmailCont.className = 'wm_hide';
		if (cont.bCompany.length > 0 || cont.bJobTitle.length > 0) {
			this._bCompanyObj.innerHTML = cont.bCompany;
			this._bCompanyTitle.innerHTML = (cont.bCompany.length > 0) ? Lang.Company + ':' : '';
			this._bJobTitleObj.innerHTML = cont.bJobTitle;
			this._bJobTitleTitle.innerHTML = (cont.bJobTitle.length > 0) ? Lang.JobTitle + ':' : '';
			this._bCompanyJobTitleCont.className = '';
			emptySection = false;
		}
		else this._bCompanyJobTitleCont.className = 'wm_hide';
		if (cont.bDepartment.length > 0 || cont.bOffice.length > 0) {
			this._bDepartmentObj.innerHTML = cont.bDepartment;
			this._bDepartmentTitle.innerHTML = (cont.bDepartment.length > 0) ? Lang.Department + ':' : '';
			this._bOfficeObj.innerHTML = cont.bOffice;
			this._bOfficeTitle.innerHTML = (cont.bOffice.length > 0) ? Lang.Office + ':' : '';
			this._bDepartmentOfficeCont.className = '';
			emptySection = false;
		}
		else this._bDepartmentOfficeCont.className = 'wm_hide';
		if (cont.bStreet.length > 0) {
			this._bStreetObj.innerHTML = cont.bStreet;
			this._bStreetCont.className = '';
			emptySection = false;
		}
		else this._bStreetCont.className = 'wm_hide';
		if (cont.bCity.length > 0 || cont.bFax.length > 0) {
			this._bCityObj.innerHTML = cont.bCity;
			this._bCityTitle.innerHTML = (cont.bCity.length > 0) ? Lang.City + ':' : '';
			this._bFaxObj.innerHTML = cont.bFax;
			this._bFaxTitle.innerHTML = (cont.bFax.length > 0) ? Lang.Fax + ':' : '';
			this._bCityFaxCont.className = '';
			emptySection = false;
		}
		else this._bCityFaxCont.className = 'wm_hide';
		if (cont.bState.length > 0 || cont.bPhone.length > 0) {
			this._bStateObj.innerHTML = cont.bState;
			this._bStateTitle.innerHTML = (cont.bState.length > 0) ? Lang.StateProvince + ':' : '';
			this._bPhoneObj.innerHTML = cont.bPhone;
			this._bPhoneTitle.innerHTML = (cont.bPhone.length > 0) ? Lang.Phone + ':' : '';
			this._bStatePhoneCont.className = '';
			emptySection = false;
		}
		else this._bStatePhoneCont.className = 'wm_hide';
		if (cont.bZip.length > 0 || cont.bCountry.length > 0) {
			this._bZipObj.innerHTML = cont.bZip;
			this._bZipTitle.innerHTML = (cont.bZip.length > 0) ? Lang.ZipCode + ':' : '';
			this._bCountryObj.innerHTML = cont.bCountry;
			this._bCountryTitle.innerHTML = (cont.bCountry.length > 0) ? Lang.CountryRegion + ':' : '';
			this._bZipCountryCont.className = '';
			emptySection = false;
		}
		else this._bZipCountryCont.className = 'wm_hide';
		if (cont.bWeb.length > 0) {
			this._contactHWeb = cont.bWeb;
			this._bWebObj.innerHTML = cont.bWeb;
			this._bWebCont.className = '';
			emptySection = false;
		}
		else this._bWebCont.className = 'wm_hide';
		if (emptySection) this._businessTbl.className = 'wm_hide';
		else this._businessTbl.className = this._sectionClassName;
	},
	
	FillOtherSection: function (cont)
	{
		var emptySection = true;
		if (cont.OtherEmail.length > 0 && cont.PrimaryEmail != PRIMARY_OTHER_EMAIL) {
			this._contactOtherEmail = (cont.UseFriendlyNm && cont.Name.length > 0)
				? '"' + cont.Name + '" <' + HtmlDecode(cont.OtherEmail) + '>'
				: HtmlDecode(cont.OtherEmail);
			this._otherEmailObj.innerHTML = cont.OtherEmail;
			this._otherEmailCont.className = '';
			emptySection = false;
		}
		else this._otherEmailCont.className = 'wm_hide';
		if (cont.Notes.length > 0) {
			this._notesObj.innerHTML = cont.Notes;
			this._notesCont.className = '';
			emptySection = false;
		}
		else this._notesCont.className = 'wm_hide';
		if (emptySection) this._otherTbl.className = 'wm_hide';
		else this._otherTbl.className = this._sectionClassName;
	},
	
	BuildDefSection: function (container)
	{
		var tbl = CreateChild(container, 'table');
		tbl.className = this._sectionClassName;
		var tr = tbl.insertRow(0);
		var td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.Name + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'Name', ':');
		td = tr.insertCell(1);
		td.className = this._nameClassName;
		this._fullnameObj = td;
		this._fullnameCont = tr;

		var tr = tbl.insertRow(1);
		var td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.Email + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'Email', ':');
		td = tr.insertCell(1);
		td.className = this._emailClassName;
		a = CreateChildWithAttrs(td, 'a', [['href', '#']]);
		this._defaultEmailObj = a;
		this._defaultEmailCont = tr;

		tr = tbl.insertRow(2);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.Birthday + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'Birthday', ':');
		td = tr.insertCell(1);
		this._birthdayObj = td;
		this._birthdayCont = tr;
	},
	
	BuildHomeSection: function (container)
	{
		var tbl = CreateChild(container, 'table');
		this._personalTbl = tbl;
		tbl.className = 'wm_hide';
		var rowIndex = 0;
		var tr = tbl.insertRow(rowIndex++);
		var td = tr.insertCell(0);
		td.className = this._sectionNameClassName;
		td.colSpan = 4;
		td.innerHTML = Lang.Home;
		WebMail.LangChanger.Register('innerHTML', td, 'Home', '');
		
		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.PersonalEmail + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'PersonalEmail', ':');
		td = tr.insertCell(1);
		td.colSpan = 3;
		var a = CreateChildWithAttrs(td, 'a', [['href', '#']]);
		a.onclick = function () { return false; };
		this._hEmailObj = a;
		this._hEmailCont = tr;

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.StreetAddress + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'StreetAddress', ':');
		td = tr.insertCell(1);
		td.colSpan = 3;
		this._hStreetObj = td;
		this._hStreetCont = tr;

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.City + ':';
		this._hCityTitle = td;
		td = tr.insertCell(1);
		this._hCityObj = td;
		td = tr.insertCell(2);
		td.className = this._titleClassName;
		td.innerHTML = Lang.Fax + ':';
		this._hFaxTitle = td;
		td = tr.insertCell(3);
		this._hFaxObj = td;
		this._hCityFaxCont = tr;

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.StateProvince + ':';
		this._hStateTitle = td;
		td = tr.insertCell(1);
		this._hStateObj = td;
		td = tr.insertCell(2);
		td.className = this._titleClassName;
		td.innerHTML = Lang.Phone + ':';
		this._hPhoneTitle = td;
		td = tr.insertCell(3);
		this._hPhoneObj = td;
		this._hStatePhoneCont = tr;

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.ZipCode + ':';
		this._hZipTitle = td;
		td = tr.insertCell(1);
		this._hZipObj = td;
		td = tr.insertCell(2);
		td.className = this._titleClassName;
		td.innerHTML = Lang.Mobile + ':';
		this._hMobileTitle = td;
		td = tr.insertCell(3);
		this._hMobileObj = td;
		this._hZipMobileCont = tr;

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.CountryRegion + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'CountryRegion', ':');
		td = tr.insertCell(1);
		td.colSpan = 3;
		this._hCountryObj = td;
		this._hCountryCont = tr;

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.WebPage + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'WebPage', ':');
		td = tr.insertCell(1);
		td.colSpan = 3;
		a = CreateChildWithAttrs(td, 'a', [['href', '#']]);
		this._hWebObj = a;
		this._hWebCont = tr;
	},
	
	BuildBusinessSection: function (container)
	{
		var tbl = CreateChild(container, 'table');
		this._businessTbl = tbl;
		tbl.className = 'wm_hide';
		var rowIndex = 0;
		var tr = tbl.insertRow(rowIndex++);
		var td = tr.insertCell(0);
		td.className = this._sectionNameClassName;
		td.colSpan = 4;
		td.innerHTML = Lang.Business;
		WebMail.LangChanger.Register('innerHTML', td, 'Business', '');
		
		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.BusinessEmail + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'BusinessEmail', ':');
		td = tr.insertCell(1);
		td.colSpan = 3;
		var a = CreateChildWithAttrs(td, 'a', [['href', '#']]);
		a.onclick = function () { return false; };
		this._bEmailObj = a;
		this._bEmailCont = tr;

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.Company + ':';
		this._bCompanyTitle = td;
		td = tr.insertCell(1);
		this._bCompanyObj = td;
		td = tr.insertCell(2);
		td.className = this._titleClassName;
		td.innerHTML = Lang.JobTitle + ':';
		this._bJobTitleTitle = td;
		td = tr.insertCell(3);
		this._bJobTitleObj = td;
		this._bCompanyJobTitleCont = tr;

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.Department + ':';
		this._bDepartmentTitle = td;
		td = tr.insertCell(1);
		this._bDepartmentObj = td;
		td = tr.insertCell(2);
		td.className = this._titleClassName;
		td.innerHTML = Lang.Office + ':';
		this._bOfficeTitle = td;
		td = tr.insertCell(3);
		this._bOfficeObj = td;
		this._bDepartmentOfficeCont = tr;

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.StreetAddress + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'StreetAddress', ':');
		td = tr.insertCell(1);
		td.colSpan = 3;
		this._bStreetObj = td;
		this._bStreetCont = tr;

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.City + ':';
		this._bCityTitle = td;
		td = tr.insertCell(1);
		this._bCityObj = td;
		td = tr.insertCell(2);
		td.className = this._titleClassName;
		td.innerHTML = Lang.Fax + ':';
		this._bFaxTitle = td;
		td = tr.insertCell(3);
		this._bFaxObj = td;
		this._bCityFaxCont = tr;

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.StateProvince + ':';
		this._bStateTitle = td;
		td = tr.insertCell(1);
		this._bStateObj = td;
		td = tr.insertCell(2);
		td.className = this._titleClassName;
		td.innerHTML = Lang.Phone + ':';
		this._bPhoneTitle = td;
		td = tr.insertCell(3);
		this._bPhoneObj = td;
		this._bStatePhoneCont = tr;

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.ZipCode + ':';
		this._bZipTitle = td;
		td = tr.insertCell(1);
		this._bZipObj = td;
		td = tr.insertCell(2);
		td.className = this._titleClassName;
		td.innerHTML = Lang.CountryRegion + ':';
		this._bCountryTitle = td;
		td = tr.insertCell(3);
		this._bCountryObj = td;
		this._bZipCountryCont = tr;

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.WebPage + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'WebPage', ':');
		td = tr.insertCell(1);
		td.colSpan = 3;
		a = CreateChildWithAttrs(td, 'a', [['href', '#']]);
		this._bWebObj = a;
		this._bWebCont = tr;
	},
	
	BuildOtherSection: function (container)
	{
		var tbl = CreateChild(container, 'table');
		this._otherTbl = tbl;
		tbl.className = 'wm_hide';
		var rowIndex = 0;
		var tr = tbl.insertRow(rowIndex++);
		var td = tr.insertCell(0);
		td.className = this._sectionNameClassName;
		td.colSpan = 2;
		td.innerHTML = Lang.Other;
		WebMail.LangChanger.Register('innerHTML', td, 'Other', '');

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.OtherEmail + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'OtherEmail', ':');
		td = tr.insertCell(1);
		a = CreateChildWithAttrs(td, 'a', [['href', '#']]);
		a.onclick = function () { return false;};
		this._otherEmailObj = a;
		this._otherEmailCont = tr;

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = this._titleClassName;
		td.innerHTML = Lang.Notes + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'Notes', ':');
		td = tr.insertCell(1);
		this._notesObj = td;
		this._notesCont = tr;
	}
};

CViewContactScreenPart.prototype = ViewContactPrototype;
CContactCard.prototype = ViewContactPrototype;
var ContactCard = new CContactCard();

function CNewContactScreenPart(skinName, parent)
{
	this._skinName = skinName;
	this._parent = parent;
	this._primaryEmail = 0;
	this.shown = false;
	this.DefEmail = '';
	
	this.Contact = new CContact();
	this.Groups = null;
	this._groupsObjs = Array();
	
	this._mainTbl = null;
	this._moreInfo = null;
	this._buttonsTbl = null;
	this._showMoreInfo = null;
	this._isMoreInfo = false;

	this._notSpecified = null;
	this._defaultEmailSel = null;
	this._defaultEmailObj = null;

	this._hEmailObj = null;
	this._fullnameObj = null;
	this._notesObj = null;
	this._useFriendlyNmObj = null;
	this._hStreetObj = null;
	this._hCityObj = null;
	this._hStateObj = null;
	this._hZipObj = null;
	this._hCountryObj = null;
	this._hPhoneObj = null;
	this._hFaxObj = null;
	this._hMobileObj = null;
	this._hWebObj = null;
	this._bEmailObj = null;
	this._bCompanyObj = null;
	this._bStreetObj = null;
	this._bCityObj = null;
	this._bStateObj = null;
	this._bZipObj = null;
	this._bCountryObj = null;
	this._bJobTitleObj = null;
	this._bDepartmentObj = null;
	this._bOfficeObj = null;
	this._bPhoneObj = null;
	this._bFaxObj = null;
	this._bWebObj = null;
	this._dayObj = null;
	this._yearObj = null;
	this._monthObj = null;
	this._otherEmailObj = null;
	this._groupsObj = null;
	
	this._tabs = Array();

	this.isCreateContact = false;
	this.isSaveContact = false;
}

CNewContactScreenPart.prototype = {
	Show: function ()
	{
		this._mainTbl.className = 'wm_contacts_view';
		if (this._isMoreInfo) {
			this._moreInfo.className = '';
		}
		else {
			this._moreInfo.className = 'wm_hide';
		};
		this._buttonsTbl.className = 'wm_contacts_view';
		this.shown = true;
	},
	
	FillDefaultEmailSel: function ()
	{
		var emails = Array(); var titles = Array();
		emails[0] = HtmlEncode(this._hEmailObj.value);		titles[0] = Lang.Personal;
		emails[1] = HtmlEncode(this._bEmailObj.value);		titles[1] = Lang.Business;
		emails[2] = HtmlEncode(this._otherEmailObj.value);	titles[2] = Lang.Other;
		if (emails[0].length == 0 && emails[1].length == 0 && emails[2].length == 0) {
			this._notSpecified.className = '';
			this._defaultEmailSel.className = 'wm_hide';
		}
		else {
			this._notSpecified.className = 'wm_hide';
			var sel = this._defaultEmailSel;
			CleanNode(sel);
			sel.className = '';
			var opts = Array();
			var existsEmail = -1;
			for (var i=0; i<=2; i++) {
				if (emails[i].length != 0) {
					opts[i] = CreateChildWithAttrs(sel, 'option', [['value', i]]);
					opts[i].innerHTML = titles[i] + ': ' + emails[i];
					if (existsEmail == -1) existsEmail = i;
				}
			};
			if (opts[this._primaryEmail]) opts[this._primaryEmail].selected = true;
			else if (existsEmail != -1) {
				opts[existsEmail].selected = true;
				this._primaryEmail = existsEmail;
			}
		}
	},
	
	ShowMoreInfo: function ()
	{
		var dEmail = this._defaultEmailObj.value;
		switch (this._primaryEmail) {
			case PRIMARY_HOME_EMAIL: this._hEmailObj.value = dEmail; break;
			case PRIMARY_BUSS_EMAIL: this._bEmailObj.value = dEmail; break;
			case PRIMARY_OTHER_EMAIL: this._otherEmailObj.value = dEmail; break;
		};
		this.FillDefaultEmailSel();
		if (this.shown) {
			this._moreInfo.className = '';
		}
		else {
			this._moreInfo.className = 'wm_hide';
		};
		this._defaultEmailObj.className = 'wm_hide';
		this._showMoreInfo.className = 'wm_hide';
		this._isMoreInfo = true;
		this._parent.ResizeBody();
	},
	
	Hide: function ()
	{
		this._mainTbl.className = 'wm_hide';
		this._moreInfo.className = 'wm_hide';
		this._buttonsTbl.className = 'wm_hide';
		this.shown = false;
	},
	
	HideMoreInfo: function ()
	{
		var emails = Array();
		emails[0] = this._hEmailObj.value;
		emails[1] = this._bEmailObj.value;
		emails[2] = this._otherEmailObj.value;
		if (emails[this._primaryEmail].length == 0) {
			if (emails[0].length != 0)
				this._primaryEmail = 0;
			else if (emails[1].length != 0)
				this._primaryEmail = 1;
			else if (emails[2].length != 0)
				this._primaryEmail = 2;
		};
		this._defaultEmailObj.value = emails[this._primaryEmail];
		this._notSpecified.className = 'wm_hide';
		this._defaultEmailSel.className = 'wm_hide';
		this._moreInfo.className = 'wm_hide';
		this._defaultEmailObj.className = 'wm_input';
		this._showMoreInfo.className = '';
		this._isMoreInfo = false;
		this._parent.ResizeBody();
	},
	
	ChangeTabMode: function (index)
	{
		this._tabs[index].ChangeTabMode(this._skinName);
		this._parent.ResizeBody();
	},
	
	CheckContactUpdate: function ()
	{
		if (this.isCreateContact) {
			WebMail.ShowReport(Lang.ReportContactSuccessfulyAdded);
			this.isCreateContact = false;
		}
		else if (this.isSaveContact) {
			WebMail.ShowReport(Lang.ReportContactUpdatedSuccessfuly);
			this.isSaveContact = false;
		}
	},
	
	FillGroups: function (groups)
	{
		this.Groups = groups;
		this._groupsObjs = Array();
		CleanNode(this._groupsObj);
		var div = CreateChildWithAttrs(this._groupsObj, 'div', [['style', 'padding: 0 0 6px 0;'], ['class', 'wm_secondary_info']]);
		div.innerHTML = Lang.InfoGroupsOfContact;
		var groupsItems = this.Groups.Items;
		var iCount = groupsItems.length;
		for (var i=0; i<iCount; i++) {
			div = CreateChildWithAttrs(this._groupsObj, 'div', [['style', 'margin: 0 0 6px 0;']]);
			var inp = CreateChildWithAttrs(div, 'input', [['type', 'checkbox'], ['class', 'wm_checkbox'], ['id', 'check_group_' + groupsItems[i].Id]]);
			inp.Name = groupsItems[i].Name;
			var lbl = CreateChildWithAttrs(div, 'label', [['for', 'check_group_' + groupsItems[i].Id]]);
			lbl.innerHTML = groupsItems[i].Name;
			this._groupsObjs[i] = inp;
		}
	},
	
	Fill: function (cont)
	{
		this.Contact = cont;
		this._primaryEmail = cont.PrimaryEmail;
		switch (cont.PrimaryEmail) {
			case PRIMARY_BUSS_EMAIL:
				this._defaultEmailObj.value = HtmlDecode(cont.bEmail);
				break;
			case PRIMARY_OTHER_EMAIL:
				this._defaultEmailObj.value = HtmlDecode(cont.OtherEmail);
				break;
			default:
				this._defaultEmailObj.value = HtmlDecode(cont.hEmail);
				break;
		}
		this._useFriendlyNmObj.checked = cont.UseFriendlyNm;
		this._fullnameObj.value = HtmlDecode(cont.Name);
		this.FillDay(cont.Day);
		this.FillMonth(cont.Month);
		this.FillYear(cont.Year);
		this._hEmailObj.value = HtmlDecode(cont.hEmail);
		this._hStreetObj.value = HtmlDecode(cont.hStreet);
		this._hCityObj.value = HtmlDecode(cont.hCity);
		this._hStateObj.value = HtmlDecode(cont.hState);
		this._hZipObj.value = HtmlDecode(cont.hZip);
		this._hCountryObj.value = HtmlDecode(cont.hCountry);
		this._hFaxObj.value = HtmlDecode(cont.hFax);
		this._hPhoneObj.value = HtmlDecode(cont.hPhone);
		this._hMobileObj.value = HtmlDecode(cont.hMobile);
		this._hWebObj.value = HtmlDecode(cont.hWeb);

		this._bEmailObj.value = HtmlDecode(cont.bEmail);
		this._bCompanyObj.value = HtmlDecode(cont.bCompany);
		this._bJobTitleObj.value = HtmlDecode(cont.bJobTitle);
		this._bDepartmentObj.value = HtmlDecode(cont.bDepartment);
		this._bOfficeObj.value = HtmlDecode(cont.bOffice);
		this._bStreetObj.value = HtmlDecode(cont.bStreet);
		this._bCityObj.value = HtmlDecode(cont.bCity);
		this._bStateObj.value = HtmlDecode(cont.bState);
		this._bZipObj.value = HtmlDecode(cont.bZip);
		this._bCountryObj.value = HtmlDecode(cont.bCountry);
		this._bFaxObj.value = HtmlDecode(cont.bFax);
		this._bPhoneObj.value = HtmlDecode(cont.bPhone);
		this._bWebObj.value = HtmlDecode(cont.bWeb);

		this._otherEmailObj.value = HtmlDecode(cont.OtherEmail);
		this._notesObj.value = HtmlDecode(cont.Notes);

		var iCount = this._groupsObjs.length;
		if (iCount > 0) {
			this._tabs[3].Show();
		}
		else {
			this._tabs[3].Hide();
		};
		for (var i=0; i<iCount; i++) {
			var id = this._groupsObjs[i].id.substring(12) - 0;
			var checked = false;
			var jCount = cont.Groups.length;
			for (var j=0; j<jCount; j++) {
				if (cont.Groups[j].Id == id)
					checked = true;
			}
			this._groupsObjs[i].checked = checked;
		};

		if (cont.onlyMainData) {
			this.HideMoreInfo();
		}
		else {
			this.ShowMoreInfo();
		};
		
		this._tabs[0].Close(this._skinName);
		this._tabs[1].Close(this._skinName);
		this._tabs[2].Close(this._skinName);
		this._tabs[3].Close(this._skinName);
		if (cont.hasHomeData || !cont.hasBusinessData && !cont.hasOtherData) {
			this._tabs[0].Open(this._skinName);
		};
		if (cont.hasBusinessData) {
			this._tabs[1].Open(this._skinName);
		};
		if (cont.hasOtherData) {
			this._tabs[2].Open(this._skinName);
		}
	},
	
	CancelChanges: function ()
	{
		var id = this.Contact.Id;
		if (id != -1) {
			SetHistoryHandler(
				{
					ScreenId: SCREEN_CONTACTS,
					Entity: PART_VIEW_CONTACT,
					IdAddr: id
				}
			);
		}
		else {
			SetHistoryHandler(
				{
					ScreenId: SCREEN_CONTACTS,
					Entity: PART_CONTACTS
				}
			);
		}
	},
	
	SaveChanges: function ()
	{
		/* validation */
		var val = new CValidate();
		var fullNameValue = this._fullnameObj.value;
		this.DefEmail = this._defaultEmailObj.value;
		var hEmailValue = this._hEmailObj.value;
		var bEmailValue = this._bEmailObj.value;
		var oEmailValue = this._otherEmailObj.value;
		switch (this._primaryEmail) {
			case PRIMARY_BUSS_EMAIL:
				if (this._isMoreInfo) this.DefEmail = bEmailValue;
				else bEmailValue = this.DefEmail;
				break;
			case PRIMARY_OTHER_EMAIL:
				if (this._isMoreInfo) this.DefEmail = oEmailValue;
				else oEmailValue = this.DefEmail;
				break;
			default:
				if (this._isMoreInfo) this.DefEmail = hEmailValue;
				else hEmailValue = this.DefEmail;
				break;
		}
		if (this.Contact.Id != -1) this.DefEmail = '';
		if (val.IsEmpty(fullNameValue) && val.IsEmpty(hEmailValue) && val.IsEmpty(bEmailValue) &&
		 val.IsEmpty(oEmailValue)) {
			alert(Lang.WarningContactNotComplete);
			return;
		}
		if (val.HasEmailForbiddenSymbols(hEmailValue) || val.HasEmailForbiddenSymbols(bEmailValue) || 
		 val.HasEmailForbiddenSymbols(oEmailValue)) {
			alert(Lang.WarningCorrectEmail);
			return;
		}
		var hWebValue = val.CorrectWebPage(this._hWebObj.value);
		var bWebValue = val.CorrectWebPage(this._bWebObj.value);

		/* saving */
		var contact = new CContact();
		contact.Id = this.Contact.Id;
		contact.PrimaryEmail = this._primaryEmail;
		contact.UseFriendlyNm = this._useFriendlyNmObj.checked;
		
		contact.Name = fullNameValue;
		contact.Day = this._dayObj.value;
		contact.Month = this._monthObj.value;
		contact.Year = this._yearObj.value;
		
		contact.hEmail = hEmailValue;
		contact.hStreet = this._hStreetObj.value;
		contact.hCity = this._hCityObj.value;
		contact.hState = this._hStateObj.value;
		contact.hZip = this._hZipObj.value;
		contact.hCountry = this._hCountryObj.value;
		contact.hFax = this._hFaxObj.value;
		contact.hPhone = this._hPhoneObj.value;
		contact.hMobile = this._hMobileObj.value;
		contact.hWeb = hWebValue;

		contact.bEmail = bEmailValue;
		contact.bCompany = this._bCompanyObj.value;
		contact.bJobTitle = this._bJobTitleObj.value;
		contact.bDepartment = this._bDepartmentObj.value;
		contact.bOffice = this._bOfficeObj.value;
		contact.bStreet = this._bStreetObj.value;
		contact.bCity = this._bCityObj.value;
		contact.bState = this._bStateObj.value;
		contact.bZip = this._bZipObj.value;
		contact.bCountry = this._bCountryObj.value;
		contact.bFax = this._bFaxObj.value;
		contact.bPhone = this._bPhoneObj.value;
		contact.bWeb = bWebValue;

		contact.OtherEmail = oEmailValue;
		contact.Notes = this._notesObj.value;

		var groupsCount = this._groupsObjs.length;
		for (var groupIndex = 0; groupIndex < groupsCount; groupIndex++) {
			var groupObj = this._groupsObjs[groupIndex];
			if (groupObj.checked)
				contact.Groups.push({Id: groupObj.id.substring(12), Name: groupObj.Name});
		}

		var xml = contact.GetInXML(this._parent.GetXmlParams());
		if (contact.Id == -1) {
			WebMail.DataSource.Cache.ClearAllContactsGroupsList();
			for (var i in contact.Groups) {
				var stringDataKey = WebMail.DataSource.GetStringDataKey(TYPE_GROUP, {IdGroup: contact.Groups[i].Id});
				WebMail.DataSource.Cache.RemoveData(TYPE_GROUP, stringDataKey);
			}
			RequestHandler('new', 'contact', xml);
			this.isCreateContact = true;
		}
		else {
			var stringDataKey = WebMail.DataSource.GetStringDataKey(contact.Type, {IdAddr: contact.Id});
			WebMail.DataSource.Cache.ReplaceData(contact.Type, stringDataKey, contact);
			switch (contact.PrimaryEmail) {
				case PRIMARY_BUSS_EMAIL: contact.Email = contact.bEmail; break;
				case PRIMARY_OTHER_EMAIL: contact.Email = contact.OtherEmail; break;
				default: contact.Email = contact.hEmail; break;
			}
			WebMail.DataSource.Cache.AddRemoveRenameContactInGroups(contact);
			switch (this.Contact.PrimaryEmail) {
				case PRIMARY_BUSS_EMAIL: this.Contact.Email = this.Contact.bEmail; break;
				case PRIMARY_OTHER_EMAIL: this.Contact.Email = this.Contact.OtherEmail; break;
				default: this.Contact.Email = this.Contact.hEmail; break;
			}
			if (this.Contact.PrimaryEmail != contact.PrimaryEmail || this.Contact.Email != contact.Email || 
				this.Contact.Name != contact.Name) {
				WebMail.DataSource.Cache.ClearAllContactsGroupsList();
			}
			RequestHandler('update', 'contact', xml);
			this.isSaveContact = true;
		}
	},
	
	FillMonth: function (month)
	{
		var obj = this;
		var sel = this._monthObj;
		CleanNode(sel);
		var opt;
		var iCount = Lang.Monthes.length;
		for (var i=0; i<iCount; i++) {
			opt = CreateChildWithAttrs(sel, 'option', [['value', i]]);
			opt.innerHTML = Lang.Monthes[i];
			if (month == i) opt.selected = true;
		};
		sel.onchange = function () {
			obj.FillDay(obj._dayObj.value);
		}
	},
	
	FillDay: function (day)
	{
		var daysInMonth = [31, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
		var year = this._yearObj.value;
		if (year == 0 || (year % 4) == 0 && (year % 100) != 0 || (year % 400) == 0) 
			daysInMonth[2] = 29;
		var month = this._monthObj.value;
		var sel = this._dayObj;
		CleanNode(sel);
		var opt = CreateChildWithAttrs(sel, 'option', [['value', 0]]);
		opt.innerHTML = Lang.Day;
		for (var i=1; i<=daysInMonth[month]; i++) {
			opt = CreateChildWithAttrs(sel, 'option', [['value', i]]);
			opt.innerHTML = i;
			if (day == i) opt.selected = true;
		};
		if (day > daysInMonth[month]) {
			opt.selected = true;
		}
	},
	
	FillYear: function (year)
	{
		var obj = this;
		var sel = this._yearObj;
		CleanNode(sel);
		var opt = CreateChildWithAttrs(sel, 'option', [['value', 0]]);
		opt.innerHTML = Lang.Year;
		var now = new Date;
		var firstYear = now.getYear();
		if (!Browser.IE)
			firstYear = firstYear + 1900;
		var lastYear = firstYear - 100;
		for (var i=firstYear; i>=lastYear; i--) {
			opt = CreateChildWithAttrs(sel, 'option', [['value', i]]);
			opt.innerHTML = i;
			if (year == i) opt.selected = true;
		};
		sel.onchange = function () {
			if (obj._monthObj.value == '2')
				obj.FillDay(obj._dayObj.value);
		}
	},
	
	TextAreaLimit: function (ev)
	{
		return TextAreaLimit(ev, this, 85);
	},
	
	Build: function (container)
	{
		var obj = this;
		var tbl = CreateChild(container, 'table');
		this._mainTbl = tbl;
		tbl.className = 'wm_hide';
		var rowIndex = 0;
		var tr = tbl.insertRow(rowIndex++);
		var td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.style.width = '25%';
		td.innerHTML = Lang.DefaultEmail + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'DefaultEmail', ':');
		td = tr.insertCell(1);
		td.style.width = '75%';
		var span = CreateChild(td, 'span');
		span.innerHTML = Lang.NotSpecifiedYet;
		WebMail.LangChanger.Register('innerHTML', span, 'NotSpecifiedYet', ':');
		span.className = 'wm_hide';
		this._notSpecified = span;
		var sel = CreateChild(td, 'select');
		sel.className = 'wm_hide';
		sel.onchange = function () { obj._primaryEmail = this.value - 0; };
		sel.style.width = '200px';
		this._defaultEmailSel = sel;
		this._defaultEmailObj = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['maxlength', '255']]);

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.ContactName + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'ContactName', ':');
		td = tr.insertCell(1);
		this._fullnameObj = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['maxlength', '85']]);

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td = tr.insertCell(1);
		this._useFriendlyNmObj = CreateChildWithAttrs(td, 'input', [['type', 'checkbox'], ['class', 'wm_checkbox'], ['id', 'use_friendly_nm_contacts']]);
		var lbl = CreateChildWithAttrs(td, 'label', [['for', 'use_friendly_nm_contacts']]);
		lbl.innerHTML = Lang.UseFriendlyName1;
		WebMail.LangChanger.Register('innerHTML', lbl, 'UseFriendlyName1', '');
		lbl = CreateChild(td, 'label');
		lbl.innerHTML = Lang.UseFriendlyName2;
		lbl.className = 'wm_secondary_info wm_inline_info';
		WebMail.LangChanger.Register('innerHTML', lbl, 'UseFriendlyName2', '');
		
		var div = CreateChild(container, 'div');
		div.className = 'wm_hide';
		this._moreInfo = div;
		tbl = CreateChild(div, 'table');
		tbl.className = 'wm_contacts_view';
		tbl.style.width = '90%';
		tbl.style.marginBottom = '20px';
		tr = tbl.insertRow(0);
		td = tr.insertCell(0);
		td.className = 'wm_hide_section';
		var a = CreateChildWithAttrs(td, 'a', [['href', '#']]);
		a.innerHTML = Lang.HideAddFields;
		WebMail.LangChanger.Register('innerHTML', a, 'HideAddFields', '');
		a.onclick = function () { obj.HideMoreInfo(); return false; };

		/*------Personal------*/
		
		var tabTbl = CreateChild(div, 'table');
		tabTbl.onclick = function () { obj.ChangeTabMode(0); };
		tabTbl.className = 'wm_contacts_tab';
		tr = tabTbl.insertRow(0);
		td = tr.insertCell(0);
		var span = CreateChild(td, 'span');
		span.className = 'wm_contacts_tab_name';
		span.innerHTML = Lang.Home;
		WebMail.LangChanger.Register('innerHTML', span, 'Home', '');
		span = CreateChild(td, 'span');
		span.className = 'wm_contacts_tab_mode';
		var img = CreateChild(span, 'img');
		img.src = 'skins/' + this._skinName + '/menu/arrow_up.gif';
		
		tbl = CreateChild(div, 'table');
		this._tabs[0] = new CContactTab(tbl, img, tabTbl);
		tbl.className = 'wm_contacts_view wm_contacts_tab_view';
		tr = tbl.insertRow(0);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.style.width = '20%';
		td.innerHTML = Lang.PersonalEmail + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'PersonalEmail', ':');
		td = tr.insertCell(1);
		td.style.width = '80%';
		td.colSpan = 4;
		var inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '45'], ['maxlength', '255']]);
		inp.onchange = function () { obj.FillDefaultEmailSel(); };
		this._hEmailObj = inp;

		tr = tbl.insertRow(1);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.StreetAddress + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'StreetAddress', ':');
		td = tr.insertCell(1);
		td.colSpan = 4;
		var txt = CreateChildWithAttrs(td, 'textarea', [['class', 'wm_input'], ['cols', '35'], ['rows', '2']]);
		txt.onkeydown = this.TextAreaLimit;
		this._hStreetObj = txt;

		tr = tbl.insertRow(2);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.style.width = '20%';
		td.innerHTML = Lang.City + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'City', ':');
		td = tr.insertCell(1);
		td.style.width = '30%';
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '65']]);
		this._hCityObj = inp;
		td = tr.insertCell(2);
		td.style.width = '10%';
		td = tr.insertCell(3);
		td.className = 'wm_contacts_view_title';
		td.style.width = '10%';
		td.innerHTML = Lang.Fax + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'Fax', ':');
		td = tr.insertCell(4);
		td.style.width = '30%';
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '50']]);
		this._hFaxObj = inp;

		tr = tbl.insertRow(3);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.StateProvince + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'StateProvince', ':');
		td = tr.insertCell(1);
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '65']]);
		this._hStateObj = inp;
		td = tr.insertCell(2);
		td = tr.insertCell(3);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.Phone + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'Phone', ':');
		td = tr.insertCell(4);
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '50']]);
		this._hPhoneObj = inp;

		tr = tbl.insertRow(4);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.ZipCode + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'ZipCode', ':');
		td = tr.insertCell(1);
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '10']]);
		this._hZipObj = inp;
		td = tr.insertCell(2);
		td = tr.insertCell(3);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.Mobile + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'Mobile', ':');
		td = tr.insertCell(4);
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '50']]);
		this._hMobileObj = inp;

		tr = tbl.insertRow(5);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.CountryRegion + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'CountryRegion', ':');
		td = tr.insertCell(1);
		td.colSpan = 4;
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '65']]);
		this._hCountryObj = inp;

		tr = tbl.insertRow(6);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.WebPage + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'WebPage', ':');
		td = tr.insertCell(1);
		td.colSpan = 4;
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '45'], ['maxlength', '85']]);
		this._hWebObj = inp;
		CreateTextChild(td, ' ');
		inp = CreateChildWithAttrs(td, 'input', [['type', 'button'], ['class', 'wm_button'], ['value', Lang.Go]]);
		WebMail.LangChanger.Register('value', inp, 'Go', '');
		inp.onclick = function () { OpenURL(obj._hWebObj.value); };

		/*------Business------*/
		
		tabTbl = CreateChild(div, 'table');
		tabTbl.onclick = function () { obj.ChangeTabMode(1); };
		tabTbl.className = 'wm_contacts_tab';
		tr = tabTbl.insertRow(0);
		td = tr.insertCell(0);
		span = CreateChild(td, 'span');
		span.className = 'wm_contacts_tab_name';
		span.innerHTML = Lang.Business;
		WebMail.LangChanger.Register('innerHTML', span, 'Business', '');
		span = CreateChild(td, 'span');
		span.className = 'wm_contacts_tab_mode';
		img = CreateChild(span, 'img');
		img.src = 'skins/' + this._skinName + '/menu/arrow_down.gif';
		
		tbl = CreateChild(div, 'table');
		this._tabs[1] = new CContactTab(tbl, img, tabTbl);
		tbl.className = 'wm_hide';
		tr = tbl.insertRow(0);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.style.width = '20%';
		td.innerHTML = Lang.BusinessEmail + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'BusinessEmail', ':');
		td = tr.insertCell(1);
		td.style.width = '80%';
		td.colSpan = 4;
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '45'], ['maxlength', '255']]);
		inp.onchange = function () { obj.FillDefaultEmailSel(); };
		this._bEmailObj = inp;

		tr = tbl.insertRow(1);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.style.width = '20%';
		td.innerHTML = Lang.Company + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'Company', ':');
		td = tr.insertCell(1);
		td.style.width = '30%';
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '65']]);
		this._bCompanyObj = inp;
		td = tr.insertCell(2);
		td.style.width = '5%';
		td = tr.insertCell(3);
		td.className = 'wm_contacts_view_title';
		td.style.width = '15%';
		td.innerHTML = Lang.JobTitle + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'JobTitle', ':');
		td = tr.insertCell(4);
		td.style.width = '30%';
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '30']]);
		this._bJobTitleObj = inp;

		tr = tbl.insertRow(2);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.Department + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'Department', ':');
		td = tr.insertCell(1);
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '65']]);
		this._bDepartmentObj = inp;
		td = tr.insertCell(2);
		td = tr.insertCell(3);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.Office + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'Office', ':');
		td = tr.insertCell(4);
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '65']]);
		this._bOfficeObj = inp;

		tr = tbl.insertRow(3);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.StreetAddress + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'StreetAddress', ':');
		td = tr.insertCell(1);
		td.colSpan = 4;
		txt = CreateChildWithAttrs(td, 'textarea', [['class', 'wm_input'], ['cols', '35'], ['rows', '2']]);
		txt.onkeydown = this.TextAreaLimit;
		this._bStreetObj = txt;

		tr = tbl.insertRow(4);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.City + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'City', ':');
		td = tr.insertCell(1);
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '65']]);
		this._bCityObj = inp;
		td = tr.insertCell(2);
		td = tr.insertCell(3);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.Fax + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'Fax', ':');
		td = tr.insertCell(4);
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '50']]);
		this._bFaxObj = inp;

		tr = tbl.insertRow(5);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.StateProvince + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'StateProvince', ':');
		td = tr.insertCell(1);
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '65']]);
		this._bStateObj = inp;
		td = tr.insertCell(2);
		td = tr.insertCell(3);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.Phone + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'Phone', ':');
		td = tr.insertCell(4);
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '50']]);
		this._bPhoneObj = inp;

		tr = tbl.insertRow(6);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.ZipCode + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'ZipCode', ':');
		td = tr.insertCell(1);
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '10']]);
		this._bZipObj = inp;
		td = tr.insertCell(2);
		td = tr.insertCell(3);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.CountryRegion + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'CountryRegion', ':');
		td = tr.insertCell(4);
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '18'], ['maxlength', '65']]);
		this._bCountryObj = inp;

		tr = tbl.insertRow(7);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.WebPage + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'WebPage', ':');
		td = tr.insertCell(1);
		td.colSpan = 4;
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '45'], ['maxlength', '85']]);
		this._bWebObj = inp;
		CreateTextChild(td, ' ');
		inp = CreateChildWithAttrs(td, 'input', [['type', 'button'], ['class', 'wm_button'], ['value', Lang.Go]]);
		WebMail.LangChanger.Register('value', inp, 'Go', '');
		inp.onclick = function () { OpenURL(obj._bWebObj.value); };

		/*------Other------*/
		
		tabTbl = CreateChild(div, 'table');
		tabTbl.onclick = function () { obj.ChangeTabMode(2); };
		tabTbl.className = 'wm_contacts_tab';
		tr = tabTbl.insertRow(0);
		td = tr.insertCell(0);
		span = CreateChild(td, 'span');
		span.className = 'wm_contacts_tab_name';
		span.innerHTML = Lang.Other;
		WebMail.LangChanger.Register('innerHTML', span, 'Other', '');
		span = CreateChild(td, 'span');
		span.className = 'wm_contacts_tab_mode';
		img = CreateChild(span, 'img');
		img.src = 'skins/' + this._skinName + '/menu/arrow_down.gif';
		
		tbl = CreateChild(div, 'table');
		this._tabs[2] = new CContactTab(tbl, img, tabTbl);
		tbl.className = 'wm_hide';
		rowIndex = 0;
		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.Birthday + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'Birthday', ':');
		td = tr.insertCell(1);
		this._monthObj = CreateChild(td, 'select');
		this._dayObj = CreateChild(td, 'select');
		this._yearObj = CreateChild(td, 'select');
		this.FillMonth(0);
		this.FillDay(0);
		this.FillYear(0);
		
		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.style.width = '20%';
		td.innerHTML = Lang.OtherEmail + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'OtherEmail', ':');
		td = tr.insertCell(1);
		td.style.width = '80%';
		td.colSpan = 4;
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '45'], ['maxlength', '255']]);
		inp.onchange = function () { obj.FillDefaultEmailSel(); };
		this._otherEmailObj = inp;

		tr = tbl.insertRow(rowIndex++);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_view_title';
		td.innerHTML = Lang.Notes + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'Notes', ':');
		td = tr.insertCell(1);
		td.colSpan = 4;
		txt = CreateChildWithAttrs(td, 'textarea', [['class', 'wm_input'], ['cols', '35'], ['rows', '2']]);
		txt.onkeydown = this.TextAreaLimit;
		this._notesObj = txt;

		/*------Groups------*/
		
		var tabTbl = CreateChild(div, 'table');
		tabTbl.onclick = function () { obj.ChangeTabMode(3); };
		tabTbl.className = 'wm_contacts_tab';
		tr = tabTbl.insertRow(0);
		td = tr.insertCell(0);
		span = CreateChild(td, 'span');
		span.className = 'wm_contacts_tab_name';
		span.innerHTML = Lang.Groups;
		WebMail.LangChanger.Register('innerHTML', span, 'Groups', '');
		span = CreateChild(td, 'span');
		span.className = 'wm_contacts_tab_mode';
		img = CreateChild(span, 'img');
		img.src = 'skins/' + this._skinName + '/menu/arrow_down.gif';
		
		tbl = CreateChild(div, 'table');
		this._tabs[3] = new CContactTab(tbl, img, tabTbl);
		tbl.className = 'wm_hide';
		tr = tbl.insertRow(0);
		td = tr.insertCell(0);
		this._groupsObj = td;

		/*------Buttons------*/

		tbl = CreateChild(container, 'table');
		this._buttonsTbl = tbl;
		tbl.className = 'wm_hide';
		tbl.style.width = '90%';
		tbl.style.marginBottom = '20px';
		tr = tbl.insertRow(0);
		td = tr.insertCell(0);
		/*rtl*/
		td.style.textAlign = window.RIGHT;
		a = CreateChildWithAttrs(td, 'a', [['href', '#']]);
		a.innerHTML = Lang.ShowAddFields;
		WebMail.LangChanger.Register('innerHTML', a, 'ShowAddFields', '');
		a.onclick = function () { obj.ShowMoreInfo(); return false; };
		this._showMoreInfo = a;
		tr = tbl.insertRow(1);
		td = tr.insertCell(0);
		td.className = 'wm_contacts_save_button';
		inp = CreateChildWithAttrs(td, 'input', [['type', 'button'], ['class', 'wm_button'], ['value', Lang.Save]]);
		WebMail.LangChanger.Register('value', inp, 'Save', '');
		inp.onclick = function () { obj.SaveChanges(); };
		CreateTextChild(td, ' ');
		inp = CreateChildWithAttrs(td, 'input', [['type', 'button'], ['class', 'wm_button'], ['value', Lang.Cancel]]);
		WebMail.LangChanger.Register('value', inp, 'Cancel', '');
		inp.onclick = function () { obj.CancelChanges(); };
	}
};

function CSelectedContactsScreenPart(parent)
{
	this._mainContainer = null;
	this._contactsContainer = null;
	this._parent = parent;
	this.shown = false;
}

CSelectedContactsScreenPart.prototype = 
{
	Show: function ()
	{
		this._mainContainer.className = '';
		this.shown = true;
	},
	
	Hide: function ()
	{
		this._mainContainer.className = 'wm_hide';
		this.shown = false;
	},
	
	Fill: function (contactsArray)
	{
		CleanNode(this._contactsContainer);
		var tbl = CreateChild(this._contactsContainer, 'table');
		tbl.className = 'wm_contacts_in_group_lines';
		tbl.style.width = 'auto';
		tbl.style.marginBottom = '20px';
		var rowIndex = 0;
		
		var tr = tbl.insertRow(rowIndex++);
		tr.className = 'wm_contacts_headers';
		var td = tr.insertCell(0);
		td.innerHTML = Lang.Email;

		var iCount = contactsArray.length;
		for (var i=0; i<iCount; i++) {
			if (contactsArray[i].length == 0) continue;
			tr = tbl.insertRow(rowIndex++);
			tr.className = 'wm_inbox_read_item';
			td = tr.insertCell(0);
			td.innerHTML = contactsArray[i];
		}
		var tblWidth = tbl.offsetWidth;
		if (tblWidth < 200) {
			tbl.style.width = '200px';
		}
	},
	
	MailSelected: function ()
	{
		this._parent.MailContacts();
	},

	Build: function (container)
	{
		var tbl = CreateChild(container, 'table');
		tbl.style.width = '100%';
		tbl.className = 'wm_hide';
		this._mainContainer = tbl;
		var tr = tbl.insertRow(0);

		var td = tr.insertCell(0);
		td.style.textAlign = 'left';
		this._contactsContainer = td;

		td = tr.insertCell(1);
		td.style.textAlign = 'right';
		td.style.verticalAlign = 'top';

		var obj = this;
		var div = CreateChildWithAttrs(td, 'div', [['style', 'float: right;']]);
		div.style.margin = '20px 20px 10px';
		div.className = 'wm_button_link wm_control';
		div.onclick = function () { obj.MailSelected(); };
		div.innerHTML = Lang.ContactsMailThem;
		WebMail.LangChanger.Register('innerHTML', div, 'MailSelected', '');
		div = CreateChildWithAttrs(container, 'div', [['style', 'width: 0; height: 0; padding: 0; overflow: hidden; clear: both;']]);
	}
};